/// <reference path="../index/node.d.ts"/>
/// <reference path="../index/mkdirp.d.ts"/>
/// <reference path="../index/colors.d.ts"/>
var fs = require('fs');
var finder = require('./finder');
var generate = require('./generate');
var pretty_print = require('./pretty_print');
var options = require('./options');
var mkdirp = require('mkdirp');
require('colors');
exports.currentInput;
exports.currentOutput;
options.todo.forEach(function (todo) {
    exports.currentInput = todo.input;
    exports.currentOutput = todo.output;
    try {
        var symbols = finder.symbols(todo.input);
        var defs = generate.defs(symbols);
        var pretty = pretty_print.pretty(defs);
        var parentPart = (/^.*\//).exec(todo.output) || [];
        var parentDir = parentPart[0] || '';
        mkdirp.sync(parentDir);
        if (fs.existsSync(todo.output) && fs.readFileSync(todo.output, 'utf8') === pretty) {
            console.error('No changes\t'.green + todo.output);
        }
        else {
            fs.writeFile(todo.output, pretty);
            console.error('Wrote\t'.red + todo.output);
        }
    }
    catch (e) {
        console.error('ERROR\t'.bold.red + todo.input + ' ' + todo.output);
        throw e;
    }
});
